/**********************************************************************
 * Copyright (c) 2005, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Variable.java,v 1.1 2007-04-09 14:04:25 samwai Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.execution.local.control;

/**
 * A Variable maps to an instance of a environment variable
 */
public class Variable {
	private String _name = null;
	private String _value = null;

	/**
	 * Create an environment variable with the specified name value pair.
	 */
	public Variable(String name, String value) {
		_name = name;
		_value = value;
	}

	/**
	 * Retrieve the name of this environment variable.
	 */
	public String getName() {
		return _name;
	}

	/**
	 * Retrieve the value of this environment variable.
	 */
	public String getValue() {
		return _value;
	}
}
