/**********************************************************************
 * Copyright (c) 2005, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SecureConnectionRequiredException.java,v 1.1 2007-04-09 14:04:25 samwai Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.execution.security;

import org.eclipse.hyades.execution.local.common.ServerSecurityInfoCommand;
import org.eclipse.hyades.execution.local.control.AgentControllerUnavailableException;

public class SecureConnectionRequiredException extends AgentControllerUnavailableException {

	private static final long serialVersionUID = 3977858458274181938L;
	ServerSecurityInfoCommand _details;

	public SecureConnectionRequiredException(ServerSecurityInfoCommand command) {
		_details = command;
	}

	public boolean isPasswordProtected() {
		return _details.isPasswordProtected();
	}

	public boolean isClientAuthenticationRequired() {
		return _details.isClientAuthenticationRequired();
	}

	public long getSecurePort() {
		return _details.getSecurePort();
	}

}
