/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CFGPropertyGroup.java,v 1.7 2009-05-05 15:46:21 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.common.common.CMNNamedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CFG Property Group</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getPropertyGroupID <em>Property Group ID</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getProperties <em>Properties</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getDefiningProperty <em>Defining Property</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getConfigurableObject <em>Configurable Object</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGPropertyGroup()
 * @model
 * @generated
 */
public interface CFGPropertyGroup extends CMNNamedElement{
	/**
	 * Returns the value of the '<em><b>Property Group ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Property Group ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Property Group ID</em>' attribute.
	 * @see #setPropertyGroupID(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGPropertyGroup_PropertyGroupID()
	 * @model
	 * @generated
	 */
	String getPropertyGroupID();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getPropertyGroupID <em>Property Group ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Property Group ID</em>' attribute.
	 * @see #getPropertyGroupID()
	 * @generated
	 */
	void setPropertyGroupID(String value);

	/**
	 * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Properties</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGPropertyGroup_Properties()
	 * @model containment="true"
	 * @generated
	 */
	EList<CFGComparableProperty> getProperties();

	/**
	 * Returns the value of the '<em><b>Defining Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Defining Property</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Defining Property</em>' reference.
	 * @see #setDefiningProperty(CFGComparableProperty)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGPropertyGroup_DefiningProperty()
	 * @model
	 * @generated
	 */
	CFGComparableProperty getDefiningProperty();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getDefiningProperty <em>Defining Property</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Defining Property</em>' reference.
	 * @see #getDefiningProperty()
	 * @generated
	 */
	void setDefiningProperty(CFGComparableProperty value);

	/**
	 * Returns the value of the '<em><b>Configurable Object</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGConfigurableObject#getPropertyGroups <em>Property Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Configurable Object</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Configurable Object</em>' container reference.
	 * @see #setConfigurableObject(CFGConfigurableObject)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGPropertyGroup_ConfigurableObject()
	 * @see org.eclipse.hyades.models.common.configuration.CFGConfigurableObject#getPropertyGroups
	 * @model opposite="propertyGroups"
	 * @generated
	 */
	CFGConfigurableObject getConfigurableObject();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup#getConfigurableObject <em>Configurable Object</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Configurable Object</em>' container reference.
	 * @see #getConfigurableObject()
	 * @generated
	 */
	void setConfigurableObject(CFGConfigurableObject value);

} // CFGPropertyGroup
