/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TPFExecutionEvent.java,v 1.10 2009-05-05 15:49:17 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.common.common.CMNAnnotation;
import org.eclipse.hyades.models.common.common.CMNDefaultProperty;
import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TPF Execution Event</b></em>'.
 * @extends IAdaptable
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getOwnerId <em>Owner Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getText <em>Text</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getEventType <em>Event Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getScriptFileURI <em>Script File URI</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getScriptLineNumber <em>Script Line Number</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getExecutionHistory <em>Execution History</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getInteractionFragment <em>Interaction Fragment</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getChildren <em>Children</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getParent <em>Parent</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getProperties <em>Properties</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getEObjectReferences <em>EObject References</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getDefectRecords <em>Defect Records</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent()
 * @model
 * @generated
 */
public interface TPFExecutionEvent extends CMNNamedElement, IAdaptable {
	/**
	 * Returns the value of the '<em><b>Owner Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owner Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Owner Id</em>' attribute.
	 * @see #setOwnerId(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_OwnerId()
	 * @model
	 * @generated
	 */
	String getOwnerId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getOwnerId <em>Owner Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owner Id</em>' attribute.
	 * @see #getOwnerId()
	 * @generated
	 */
	void setOwnerId(String value);

	/**
	 * Returns the value of the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Timestamp</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timestamp</em>' attribute.
	 * @see #setTimestamp(long)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Timestamp()
	 * @model
	 * @generated
	 */
	long getTimestamp();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getTimestamp <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timestamp</em>' attribute.
	 * @see #getTimestamp()
	 * @generated
	 */
	void setTimestamp(long value);

	/**
	 * Returns the value of the '<em><b>Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Text</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Text</em>' attribute.
	 * @see #setText(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Text()
	 * @model
	 * @generated
	 */
	String getText();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getText <em>Text</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Text</em>' attribute.
	 * @see #getText()
	 * @generated
	 */
	void setText(String value);

	/**
	 * Returns the value of the '<em><b>Event Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Type</em>' attribute.
	 * @see #setEventType(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_EventType()
	 * @model
	 * @generated
	 */
	String getEventType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getEventType <em>Event Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Type</em>' attribute.
	 * @see #getEventType()
	 * @generated
	 */
	void setEventType(String value);

	/**
	 * Returns the value of the '<em><b>Script File URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Script File URI</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Script File URI</em>' attribute.
	 * @see #setScriptFileURI(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_ScriptFileURI()
	 * @model
	 * @generated
	 */
	String getScriptFileURI();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getScriptFileURI <em>Script File URI</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Script File URI</em>' attribute.
	 * @see #getScriptFileURI()
	 * @generated
	 */
	void setScriptFileURI(String value);

	/**
	 * Returns the value of the '<em><b>Script Line Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Script Line Number</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Script Line Number</em>' attribute.
	 * @see #setScriptLineNumber(long)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_ScriptLineNumber()
	 * @model
	 * @generated
	 */
	long getScriptLineNumber();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getScriptLineNumber <em>Script Line Number</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Script Line Number</em>' attribute.
	 * @see #getScriptLineNumber()
	 * @generated
	 */
	void setScriptLineNumber(long value);

	/**
	 * Returns the value of the '<em><b>Execution History</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory#getExecutionEvents <em>Execution Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Execution History</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Execution History</em>' container reference.
	 * @see #setExecutionHistory(TPFExecutionHistory)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_ExecutionHistory()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory#getExecutionEvents
	 * @model opposite="executionEvents" required="true"
	 * @generated
	 */
	TPFExecutionHistory getExecutionHistory();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getExecutionHistory <em>Execution History</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Execution History</em>' container reference.
	 * @see #getExecutionHistory()
	 * @generated
	 */
	void setExecutionHistory(TPFExecutionHistory value);

	/**
	 * Returns the value of the '<em><b>Interaction Fragment</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interaction Fragment</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interaction Fragment</em>' reference.
	 * @see #setInteractionFragment(BVRInteractionFragment)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_InteractionFragment()
	 * @model
	 * @generated
	 */
	BVRInteractionFragment getInteractionFragment();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getInteractionFragment <em>Interaction Fragment</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interaction Fragment</em>' reference.
	 * @see #getInteractionFragment()
	 * @generated
	 */
	void setInteractionFragment(BVRInteractionFragment value);

	/**
	 * Returns the value of the '<em><b>Children</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Children</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Children</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Children()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getParent
	 * @model opposite="parent" containment="true"
	 * @generated
	 */
	EList<TPFExecutionEvent> getChildren();

	/**
	 * Returns the value of the '<em><b>Parent</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent</em>' container reference.
	 * @see #setParent(TPFExecutionEvent)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Parent()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getChildren
	 * @model opposite="children"
	 * @generated
	 */
	TPFExecutionEvent getParent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent#getParent <em>Parent</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent</em>' container reference.
	 * @see #getParent()
	 * @generated
	 */
	void setParent(TPFExecutionEvent value);

	/**
	 * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.common.CMNDefaultProperty}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Properties</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Properties()
	 * @model containment="true"
	 * @generated
	 */
	EList<CMNDefaultProperty> getProperties();

	/**
	 * Returns the value of the '<em><b>Annotations</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.common.CMNAnnotation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Annotations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Annotations</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_Annotations()
	 * @model containment="true"
	 * @generated
	 */
	EList<CMNAnnotation> getAnnotations();

	/**
	 * Returns the value of the '<em><b>EObject References</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.EObjectReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>EObject References</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>EObject References</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_EObjectReferences()
	 * @model containment="true"
	 * @generated
	 */
	EList<EObjectReference> getEObjectReferences();

	/**
	 * Returns the value of the '<em><b>Defect Records</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord#getExecutionEvent <em>Execution Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Defect Records</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Defect Records</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFExecutionEvent_DefectRecords()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord#getExecutionEvent
	 * @model opposite="executionEvent" containment="true"
	 * @generated
	 */
	EList<TPFRepositoryRecord> getDefectRecords();

} // TPFExecutionEvent
