/**********************************************************************
 * Copyright (c) 2003, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: HierarchyFactory.java,v 1.2 2007-12-01 00:06:20 apnan Exp $
 **********************************************************************/

/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy;

import java.util.Map;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage
 * @generated
 */
public interface HierarchyFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	HierarchyFactory eINSTANCE = org.eclipse.hyades.models.hierarchy.impl.HierarchyFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>TRC Process Proxy</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Process Proxy</em>'.
	 * @generated
	 */
	TRCProcessProxy createTRCProcessProxy();

	/**
	 * Returns a new object of class '<em>TRC Option</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Option</em>'.
	 * @generated
	 */
	TRCOption createTRCOption();

	/**
	 * Returns a new object of class '<em>TRC Agent</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Agent</em>'.
	 * @generated
	 */
	TRCAgent createTRCAgent();

	/**
	 * Returns a new object of class '<em>TRC Agent Proxy</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Agent Proxy</em>'.
	 * @generated
	 */
	TRCAgentProxy createTRCAgentProxy();

	/**
	 * Returns a new object of class '<em>TRC Configuration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Configuration</em>'.
	 * @generated
	 */
	TRCConfiguration createTRCConfiguration();

	/**
	 * Returns a new object of class '<em>TRC Environment Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Environment Variable</em>'.
	 * @generated
	 */
	TRCEnvironmentVariable createTRCEnvironmentVariable();

	/**
	 * Returns a new object of class '<em>TRC Exec Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Exec Parameter</em>'.
	 * @generated
	 */
	TRCExecParameter createTRCExecParameter();

	/**
	 * Returns a new object of class '<em>TRC Filter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Filter</em>'.
	 * @generated
	 */
	TRCFilter createTRCFilter();

	/**
	 * Returns a new object of class '<em>TRC Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Node</em>'.
	 * @generated
	 */
	TRCNode createTRCNode();

	/**
	 * Returns a new object of class '<em>TRC Monitor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Monitor</em>'.
	 * @generated
	 */
	TRCMonitor createTRCMonitor();

	/**
	 * Returns a new object of class '<em>Unresolved Correlation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Unresolved Correlation</em>'.
	 * @generated
	 */
	UnresolvedCorrelation createUnresolvedCorrelation();

	/**
	 * Returns a new object of class '<em>Correlation Source Info</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Correlation Source Info</em>'.
	 * @generated
	 */
	CorrelationSourceInfo createCorrelationSourceInfo();

	/**
	 * Returns a new object of class '<em>Correlation Container</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Correlation Container</em>'.
	 * @generated
	 */
	CorrelationContainer createCorrelationContainer();

	/**
	 * Returns a new object of class '<em>Correlation Container Proxy</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Correlation Container Proxy</em>'.
	 * @generated
	 */
	CorrelationContainerProxy createCorrelationContainerProxy();

	/**
	 * Returns a new object of class '<em>Correlation Engine</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Correlation Engine</em>'.
	 * @generated
	 */
	CorrelationEngine createCorrelationEngine();

	public Map.Entry<EObject, EList<EObject>> createCorrelationEntry();
	
	/**
	 * Returns a new object of class '<em>TRC Annotation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Annotation</em>'.
	 * @generated
	 */
	TRCAnnotation createTRCAnnotation();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	HierarchyPackage getHierarchyPackage();

} //HierarchyFactory
