/**********************************************************************
 * Copyright (c) 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: 
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.trace.views.util.internal;


import org.eclipse.hyades.trace.views.util.internal.ColumnData;


public final class ColumnDataHelper {
	private int _styleWas;
	static private ColumnDataHelper _instance;

	static public synchronized ColumnDataHelper getInstance() {
		if (null == _instance)
			_instance = new ColumnDataHelper();
		return _instance;
	}

	private ColumnDataHelper() {
		_instance = this;
		setStyleWas(17);
	}

	private void setStyleWas(int _styleWas) {
		this._styleWas = _styleWas;
	}

	private int getStyleWas() {
		return _styleWas;
	}
	
	public int updateStyle(int style)
	{
		if ((style & ColumnData.NOT_VISIBLE_CHOOSE_COLUMNS) != 0) {
			style = getStyleWas();
		}
		else {
			setStyleWas(style);
			if ((style & ColumnData.IS_VISIBLE) != 0) {
				style &= ~ColumnData.IS_VISIBLE;
			}
			style |= ColumnData.NOT_VISIBLE_CHOOSE_COLUMNS;
		}
		return style;
	}
		
	
}
