/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.ui.internal.editor.action;

import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.texteditor.IWorkbenchActionDefinitionIds;

public class SelectAllAction extends EditAction
{
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#getActionDefinitionId()
	 */
	public String getActionDefinitionId()
	{
		return IWorkbenchActionDefinitionIds.SELECT_ALL;
	}

	public void run()
	{
		Control control = getFocusControl();
		if (control instanceof Text)
		{
			((Text)control).selectAll();
		}
		else if (control instanceof StyledText)
		{
			StyledText styledText = (StyledText)control;
			styledText.setSelection(0,styledText.getText().length());
		}
	}
}
