/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IUserPreferencesConstants.java,v 1.1 2005-03-30 08:26:40 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.part;

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IUserPreferencesConstants.java,v 1.1 2005-03-30 08:26:40 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/


/**
 * <code>IUserPreferencesConstants</code> interface defines the constants used
 * by classes implementing user preferences.
 * 
 * $Revision: 1.1 $
 */
public interface IUserPreferencesConstants {
	/*
	 * Palette internal identifiers (used to avoid translation issues)
	 */
	String SEASIDE= "ZZ1";
	String SUMMER= 	"ZZ2";
	String EARTH= 	"ZZ3";
	String SPRING= 	"ZZ4";
	String HARVEST=	"ZZ5";
	String PASTEL= 	"ZZ6";	
	
	/*
	 * User preference page constants. Note to users: do not use 
	 * names beginning with "prefs_" for custom preference pages.
	 */	
	String PREFS=						"prefs_"; 
	String PREFS_WIDTH=					"430";	
	String NS_PREFS_WIDTH=				"360";	
	String BAR_PREFS= 					"bar.htm";	
	String BAR_PREFS_HEIGHT=			"435";	
	String NS_BAR_PREFS_HEIGHT=			"460";	
	String BAR_PREFS3D= 				"bar.htm";	
	String BAR_PREFS_HEIGHT3D=			"435";	
	String NS_BAR_PREFS_HEIGHT3D=		"460";	
	String STACKBAR_PREFS= 				"bar.htm";
	String STACKBAR_PREFS_HEIGHT=		"435";		
	String NS_STACKBAR_PREFS_HEIGHT=	"460";	
	String STACKBAR_PREFS3D= 			"bar.htm";
	String STACKBAR_PREFS_HEIGHT3D=		"435";		
	String NS_STACKBAR_PREFS_HEIGHT3D=	"460";	
	String LINE_PREFS= 					"line.htm";
	String LINE_PREFS_HEIGHT=			"495";		
	String NS_LINE_PREFS_HEIGHT=		"520";	
	String AREA_PREFS= 					"line.htm";
	String AREA_PREFS_HEIGHT=			"495";		
	String NS_AREA_PREFS_HEIGHT=		"520";	
	String SCATTER_PREFS= 				"bar.htm";
	String SCATTER_PREFS_HEIGHT=		"435";		
	String NS_SCATTER_PREFS_HEIGHT=		"520";	
	String PIE_PREFS= 					"pie.htm";
	String PIE_PREFS_HEIGHT=			"460";	
	String NS_PIE_PREFS_HEIGHT=			"480";	
	String PIE_PREFS3D= 				"pie.htm";
	String PIE_PREFS_HEIGHT3D=			"460";	
	String NS_PIE_PREFS_HEIGHT3D=		"480";	
	String METER_PREFS= 				"meter.htm";
	String METER_PREFS_HEIGHT=			"350";
	String NS_METER_PREFS_HEIGHT=		"320";
	String NS_PREFS=					"indexs.html";	

}
